<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

/** 
 * Table of Contents
 * 
 * 1. Shortcode
 * 2. Elementor Widget Creator
 */

//1. Shortcode
function orrf_builder($params, $content) {
    extract( shortcode_atts( 
        array(
            'max_guests'                 => '',
            'color'                      => '',
            'color_hover'                => '',
            'bg_color'                   => '',
            'bg_color_hover'             => '',
            'submit_button_label'        => '',
            'action_url'                => '',
            'action_id'                => '',
            'heading'                => '',
            'select'                => '',

        ), $params ) ); 

    	// CSS
        wp_enqueue_style( 'orrf-custom', plugins_url( 'assets/css/custom.css', __FILE__ ), array(), '1.0.0', 'all' );
        
	    ob_start(); 

        $guests_id = uniqid('guests-number-');
        $sd_id = uniqid('sd-number-');
        $partysize_id = uniqid('partysize-number-');
        $datetime_id = uniqid('datetime-number-');
        $form_id = uniqid('form-id-');
        
        if($select == $action_id){
            $action_url = "https://www.opentable.com/restref/client/";
        }
	    ?>
            <div class="mt-opentable-restaurant-reservation-forms">
                <form action="<?php echo esc_attr($action_url); ?>" method="get" id="<?php echo esc_attr($form_id); ?>">
                    <div class="orrf_row">
                        <div class="orrf_input_wrapper">
                            <h2 class="orrf_heading"><?php echo esc_attr($heading)?></h2>
                            <?php if($select == "action_url"){ ?>
                                <div class="mt_single_builder_field mt_field--input_number">
                                    <label for="<?php echo esc_attr($guests_id); ?>"><?php echo esc_html__('Party Size', 'orrf');?></label>
                                        <input class="form-control" value="<?php echo esc_attr($action_id); ?>" name="rid" type="hidden">
                                    <input id="<?php echo esc_attr($guests_id); ?>" required type="number" value name="p" min="1" max="<?php echo esc_attr($max_guests);?>" placeholder="<?php echo esc_attr('Number Of Guests', 'orrf');?>" class="form-control" />
                                </div>
                                <div class="orrf-date-wrapper">
                                    <div class="mt_single_builder_field mt_field--input_datepicker">
                                        <label for="<?php echo esc_attr($sd_id); ?>"><?php esc_html_e( 'Select Date and Time:', 'orrf' ); ?></label>
                                        <input type="datetime-local" id="<?php echo esc_attr($sd_id); ?>" name="sd" class="date-picker">
                                    </div>
                                </div>
                            <?php } else {?>
                                <div class="mt_single_builder_field mt_field--input_number">
                                    <label for="<?php echo esc_attr($partysize_id); ?>"><?php echo esc_html__('Party Size', 'orrf');?></label>
                                    <input id="<?php echo esc_attr($partysize_id); ?>" required type="number" value name="partysize" min="1" max="<?php echo esc_attr($max_guests);?>" placeholder="<?php echo esc_attr('Number Of Guests', 'orrf');?>" class="form-control" />
                                    <input class="form-control" value="<?php echo esc_attr($action_id); ?>" name="rid" type="hidden">
                                </div>
                                <div class="orrf-date-wrapper">
                                    <div class="mt_single_builder_field mt_field--input_datepicker">
                                        <label for="<?php echo esc_attr($datetime_id); ?>"><?php esc_html_e( 'Select Date and Time:', 'orrf' ); ?></label>
                                        <input type="datetime-local" id="<?php echo esc_attr($datetime_id); ?>" name="datetime" class="date-picker">
                                    </div>
                                </div>
                            <?php } ?>
                        </div>
                        <div class="orrf-btn-group">
                            <input type="submit" formtarget="_blank" class="rippler rippler-default button-winona btn btn-lg tabs_button orrf-submit" domain="submit" value="<?php echo esc_attr($submit_button_label);?>" />
                        </div>
                    </div>
                </form>
            </div>
            <?php

	    return ob_get_clean();

	}
add_shortcode('orrf-builder-shortcode', 'orrf_builder');


// 2. Elementor Widget Creator
if (in_array('elementor/elementor.php', apply_filters('active_plugins', get_option('active_plugins')))) {
	class ORRF_Elementor_Widgets {

		protected static $instance = null;

		public static function get_instance() {
			if ( ! isset( static::$instance ) ) {
				static::$instance = new static;
			}

			return static::$instance;
		}

		protected function __construct() {
			require_once('elementor.php');

			add_action( 'elementor/widgets/widgets_registered', [ $this, 'register_widgets' ] );
		}

		public function register_widgets() {
			\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new \Elementor\ORRF_Widget() );
		}

	}

	// Elementor Init
	add_action( 'init', 'orrf_elementor_init' );
	function orrf_elementor_init() {
		ORRF_Elementor_Widgets::get_instance();
	}

	// Elementor Widgets Category
	function orrf_widget_categories( $elements_manager ) {
		$elements_manager->add_category(
			'modeltheme-widgets',
			[
				'title' => esc_html__( 'Modeltheme Widgets', 'orrf' ),
				'icon' => 'fas fa-plug',
			]
		);
	}
	add_action( 'elementor/elements/categories_registered', 'orrf_widget_categories' );
}

#310610